//---------------------------------------------------------------------------------------
//
//	ComboBoxMain.h -- Header for ComboBox external area procedures
//
//	Copyright 1995-1996, Pensacola Christian College
//
//	======================================================================
//	Change History
//	======================================================================
//
//	1.0			08/  /95		Steve Dwire
//											Initial release
//
//	1.0.1		10/18/95		Steve Dwire
//											"#pragma export" for Main()
//
//	1.1			11/28/95		Steve Dwire
//											Added CB_GetFontNum() to return font number from name.
//											Added AreaStruct() to draw area in layout editor.
//
//---------------------------------------------------------------------------------------

#ifndef __COMBOBOX_H__
#include "ComboBox.h"
#endif

#if defined(powerc)
#pragma export on
pascal void Main(SLONG entryPoint, PackagePtr params, PackHnd *PackData, ResultPtr result);
#pragma export off
#else
#if WINVER
void pascal FourDPack(SLONG entryPoint, PackagePtr params, PackHnd *PackData, ResultPtr result);
#else
pascal void main(SLONG entryPoint, PackagePtr params, PackHnd *PackData, ResultPtr result);
#endif
#endif

OSErr Area(EventRecord *event, Rect *bounds, UBYTE *name, AreaHnd *AreaData);

void InitPackageData(PackHnd PackData);
void LaunchListProcess(PackHnd PackData);
OSErr InitAreaData(AreaHnd* AreaDataHndPtr,PackHnd PackDataHnd,
									 Rect* AreaRect, EventRecord* event);
void InitAreaDefaults (AreaPtr AreaDataPtr, PackHnd PackDataHnd);
OSErr InitAreaStructs(AreaPtr AreaDataPtr, Rect* AreaRect, PackHnd PackDataHnd);
void InitAreaPICT (AreaPtr AreaDataPtr);
OSErr InitAreaText(AreaPtr AreaDataPtr);
OSErr InitAreaList (AreaPtr AreaDataPtr, PackHnd PackDataHnd);
void DeInitAreaData (AreaHnd AreaDataHnd);
//v1.1
// added following line:
void AreaStruct(UBYTE *name, Rect *bounds, PackHnd PackDataHnd);
// to draw area in layout editor
PackHnd	GetPackDataHnd(void);

void AreaCursor(AreaHnd AreaData, EventRecord* event);
void AreaMouseDown(AreaHnd AreaData, EventRecord* event);
void AreaScrollRect(AreaHnd AreaDataHnd, Rect* AreaRect);
void AreaUpdate(AreaHnd AreaData, EventRecord* event);
void AreaKeyDown(AreaHnd AreaData, EventRecord* event);
Boolean AreaSearchList(SBYTE *TextPtr, SWORD TextLength, AreaHnd AreaDataHnd);
OSErr AreaSelect(AreaHnd AreaDataHnd, EventRecord* event);
void AreaDeselect(AreaHnd AreaDataHnd);
void AreaCut(AreaHnd AreaData);
void AreaCopy(AreaHnd AreaData);
void AreaPaste(AreaHnd AreaData);
void AreaClear(AreaHnd AreaData);
void AreaSelectAll(AreaHnd AreaData);
MouseLocType GetMouseLoc(AreaHnd AreaData, EventRecord* event);
void AreaCreateList(AreaHnd AreaDataHnd);
OSErr AreaShowList(AreaHnd AreaDataHnd);
void AreaHideList(AreaHnd AreaDataHnd);
void CalcTextRect (AreaPtr AreaDataPtr);
void CalcListRect(AreaPtr AreaDataPtr);
void RedrawList(AreaPtr	AreaDataPtr);

void CB_SetDefTxtFnt(PackHnd PackDataHnd, SWORD FontNum, SWORD FontSize, SWORD FontStyle);
void CB_SetDefTxtCol(PackHnd PackDataHnd, SWORD ForeColor, SWORD BackColor);
void CB_SetDefLstFnt(PackHnd PackDataHnd, SWORD FontNum, SWORD FontSize, SWORD FontStyle);
void CB_SetDefLstCol(PackHnd PackDataHnd, SWORD ForeColor, SWORD BackColor);
void CB_SetDefLstRws(PackHnd PackDataHnd, SWORD Rows);
void CB_SetDefPopPic(PackHnd PackDataHnd, SWORD CUp, SWORD CDown, SWORD CDis, SWORD MUp, SWORD MDown, SWORD MDis);
void CB_SetDefGap(PackHnd PackDataHnd, SWORD Pict, SWORD Top, SWORD Left, SWORD Right);
void CB_SetDefLead(PackHnd PackDataHnd, SWORD Lead);
void CB_SetDefFlags(PackHnd PackDataHnd, SWORD CanFind, SWORD CanFill, SWORD CanList, SWORD CanEdit, SWORD ListOnActivate, SWORD ListOnKeystroke);
void CB_SetTxtFnt(AreaHnd AreaDataHnd, SWORD FontNum, SWORD FontSize, SWORD FontStyle);
void CB_SetTxtCol(AreaHnd AreaDataHnd, SWORD ForeColor, SWORD BackColor);
void CB_SetLstFnt(AreaHnd AreaDataHnd, SWORD FontNum, SWORD FontSize, SWORD FontStyle);
void CB_SetLstCol(AreaHnd AreaDataHnd, SWORD ForeColor, SWORD BackColor);
void CB_SetLstRws(AreaHnd AreaDataHnd, SWORD Rows);
SLONG CB_GetLstRws(AreaHnd AreaDataHnd);
void CB_SetPopPic(AreaHnd AreaDataHnd, SWORD CUp, SWORD CDown, SWORD CDis, SWORD MUp, SWORD MDown, SWORD MDis);
void CB_SetGap(AreaHnd AreaDataHnd, SWORD Pict, SWORD Top, SWORD Left, SWORD Right);
void CB_SetLead(AreaHnd AreaDataHnd, SWORD Lead);
void CB_SetFlags(AreaHnd AreaDataHnd, SWORD CanFind, SWORD CanFill, SWORD CanList, SWORD CanEdit, SWORD ListOnActivate, SWORD ListOnKeystroke);
void CB_FillLst(AreaHnd AreaDataHnd, UBYTE* ListArrName);
void CB_UpdateLst(AreaHnd AreaDataHnd);
void CB_SetLstPos(AreaHnd AreaDataHnd, SWORD Position);
SLONG CB_GetLstPos(AreaHnd AreaDataHnd);
void CB_SetTxt(AreaHnd AreaDataHnd, TextBlock* TextText);
void CB_GetTxt(AreaHnd AreaDataHnd, TextBlock* TextText);
void CB_SetModified(AreaHnd AreaDataHnd, SWORD Modified);
SLONG CB_GetModified(AreaHnd AreaDataHnd);
void CB_SetEnabled(AreaHnd AreaDataHnd, SWORD Enabled);
SLONG CB_GetEnabled(AreaHnd AreaDataHnd);
void CB_SetHilite(AreaHnd AreaDataHnd, SWORD Start, SWORD End);
void CB_GetHilite(AreaHnd AreaDataHnd, SWORD* Start, SWORD* End);
//v1.1
// added the following line:
SLONG CB_GetFontNum(UBYTE* FontName);
// to handle CB_GetFontNum function
void ListSynchronize(AreaPtr AreaDataPtr);